#!/usr/bin/perl

#┌─────────────────────────────────
#│ HONEY BOARD : admin.cgi - 2019/12/22
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Honey Board v6.1 PLUS : admin.cgi - 2019/12/23
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
cgi_err('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 処理分岐
if ($in{data_men}) { data_men(); }
if ($in{pass_mgr}) { pass_mgr(); }

# メニュー画面
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	print <<EOM;
<div class="all">
<p>選択ボタンを押してください。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="form-tbl">
<tr>
	<th>選択</th>
	<th width="280">処理メニュー</th>
</tr><tr>
	<td><input type="submit" name="data_men" value="選択"></td>
	<td>データ管理</td>
</tr><tr>
	<td><input type="submit" name="pass_mgr" value="選択"></td>
	<td>パスワード管理</td>
</tr><tr>
	<td><input type="button" value="選択" onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>掲示板へ戻る</td>
</tr><tr>
	<td><input type="submit" name="logoff" value="選択"></td>
	<td>ログアウト</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  データ管理
#-----------------------------------------------------------
sub data_men {
	# 編集フォーム
	if ($in{mode_edit} && $in{no}) {
		if ($in{no} =~ /\0/) { cgi_err('複数記事が選択されています'); }

		my $log;
		open(DAT,"$cf{logfile}") or cgi_err("open err: $cf{logfile}");
		my $top = <DAT>;
		while (<DAT>) {
			my ($no) = (split(/<>/))[0];

			if ($in{no} == $no) {
				$log = $_;
				last;
			}
		}
		close(DAT);

		# 編集フォーム
		edit_form($log);

	# 編集実行
	} elsif ($in{mode_edit2} && $in{no}) {
		# URL
		if ($in{url} eq 'http://') { $in{url} = ''; }

		# アイコン
		my $icon = (split(/,/, $cf{icon}->[$in{icon}]))[0];

		# 文字色
		my $color = (split(/\s+/,$cf{colors}))[$in{color}];

		my (@data,$ext2,$w2,$h2);
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$nam,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
			if ($no == $in{no}) {

				# アップロード
				if ($in{upfile}) { ($ext2,$w2,$h2) = upload($in{no}); }

				# 添付削除
				if ($in{del}) {
					unlink("$cf{upldir}/$in{no}$ex");
					unlink("$cf{upldir}/$in{no}-s$ex") if (-f "$cf{upldir}/$in{no}-s$ex");
					$ex = $w = $h = '';
				}

				# 添付アップロードの場合
				if ($ext2) {
					# 拡張子変更の場合旧ファイル削除
					if ($ex && $ext2 ne $ex) {
						unlink("$cf{upldir}/$in{no}$ex");
						unlink("$cf{upldir}/$in{no}-s$ex") if (-f "$cf{upldir}/$in{no}-s$ex");
					}
					# 新添付ファイル情報
					($ex,$w,$h) = ($ext2,$w2,$h2);
				}

				$_ = "$no<>$reno<>$date<>$in{name}<>$in{email}<>$in{sub}<>$icon<><>$in{comment}<>$color<>$in{url}<>$host<>$pw<>$ex<>$w<>$h<>$in{col3}<>$in{youtube}<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 削除処理
	} elsif ($in{mode_dele} && $in{no}) {

		my %del;
		foreach ( split(/\0/,$in{no}) ) {
			$del{$_}++;
		}

		# 削除情報をマッチングし更新
		my @data;
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno) = (split(/<>/))[0,1];
			next if (defined($del{$no}));
			next if (defined($del{$reno}));

			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	header("管理モード");
	back_btn();
	print <<EOM;
<div class="all">
<div class="sub-ttl"> データ管理 : 編集</div>
<ul>
<li>親記事を削除するとレス記事も一括して削除されます。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="data_men" value="1">
<input type="submit" name="mode_edit" value="修正する">
<input type="submit" name="mode_dele" value="削除する">
EOM

	my $i = 0;
	open(IN,"$cf{logfile}") or cgi_err("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$mail,$sub,$icon,$icon2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
	my @col = split(/\s+/,$cf{colors});

			print qq|<div align="center">|;
		if (!$reno) {
			print qq|<div class="log" style="border-color:$col3">|;
		} else {
			print qq|<div class="sub" style="border-color:#e6e4e3">|;
		}

		# 削除チェックボックス
		print qq|<input type="checkbox" name="no" value="$no">|;
		print qq|No.<span style="color:#00a1e9">$no</span> <b style="color:#941f57">$sub</b> 投稿者：<b style="color:#8d93c8">$name</b> 日時：<span style="color:green">$date</span>  [<span style="color:#ed6d46">$host</span>]|;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			print qq|&nbsp;&nbsp;《 添付|;
			print qq|：<a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> ($size) 》|;
		}
		print qq|<div class="icon"><img src="$cf{imgurl}/$icon" alt="" /></div>\n|;
		print qq|<div class="com"><span style="color:$col">$com</span></div>\n|;
		print qq|</div></div>\n|;
	}
	close(IN);

	print <<EOM;
</form>
<hr>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  編集フォーム
#-----------------------------------------------------------
sub edit_form {
	my $log = shift;
	my ($no,$reno,$date,$name,$eml,$sub,$icon,$icon2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/,$log);
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	# アイコン
	my $op_ico;
	foreach (0 .. $#{$cf{icon}}) {
		my ($file,$name) = split(/,/, $cf{icon}->[$_]);
		if ($icon eq $file) {
			$op_ico .= qq|<option value="$_" selected>$name\n|;
		} else {
			$op_ico .= qq|<option value="$_">$name\n|;
		}
	}

	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $op_col;
	foreach (0 .. $#col) {
		if ($col[$_] eq $col) {
			$op_col .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$op_col .= qq|<input type="radio" name="color" value="$_">|;
		}
		$op_col .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $col3) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	my $clip;
	if ($ex) {
		$clip .= qq|[<a href="$cf{uplurl}/$no$ex" target="_blank">添付</a>]\n|;
		$clip .= qq|<input type="checkbox" name="del" value="1">削除\n|;
	}

	header('管理TOP &gt; 編集フォーム');
	back_btn('data_men');
	print <<EOM;
<div class="all">
<div class="sub-ttl"> 編集フォーム</div>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="data_men" value="1">
<input type="hidden" name="mode_edit2" value="1">
<input type="hidden" name="no" value="$in{no}">
<table class="edit-fm">
<tr>
	<th>なまえ</th>
	<td><input type="text" name="name" size="30" class="reg-name" value="$name"></td>
</tr><tr>
	<th>E-mail</th>
	<td><input type="text" name="email" size="30" class="reg-name" value="$eml"></td>
</tr><tr>
	<th>タイトル</th>
	<td><input type="text" name="sub" size="36" class="reg-ttl" value="$sub"></td>
</tr><tr>
	<th>コメント</th>
	<td><textarea name="comment" class="reg-com" rows="7">$com</textarea></td>
</tr><tr>
	<th>参照先</th>
	<td><input type="text" name="url" size="55" class="reg-url" value="$url"></td>
</tr><tr>
	<th>アイコン</th>
	<td>
		<select name="icon">
		$op_ico
		</select>
	</td>
</tr><tr>
	<th>枠色</th>
	<td>
		<select name="col3">
		$color_b
		</select>
	</td>
</tr><tr>
	<th>文字色</th>
	<td>$op_col</td>
</tr><tr>
	<th>貼\付種別</th>
	<td>
	<label><input type="radio" name="clip" value="" onclick="entryChange();" checked="checked" />ファイルアップ</label>
	<label><input type="radio" name="clip" value="" onclick="entryChange();" />YouTube ID</label>
	</td>
</tr>
<tr id="ibox">
  	<th>ファイルアップ</th>
  	<td>
	<input type="file" name="upfile" size="36" />
		$clip
	</td>
</tr>
<tr id="ybox">
	<th>YouTube ID</th>
	<td>
		<textarea name="youtube" cols="60" rows="3">$tube</textarea>
	</td>
</tr><tr>
	<th></th>
	<td><input type="submit" value="編集する"></td>
</tr>
</table>
</form>
<p></p>
<hr class="bottom" />
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my ($ttl,$js) = @_;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="content-style-type" content="text/css" />
<meta http-equiv="content-script-type" content="text/javascript" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<script type="text/javascript"> 
var ua = navigator.userAgent;
if(ua.indexOf('iPhone') != -1 || ua.indexOf('Android') != -1){
//iPhone & Android
document.write('<link rel="stylesheet" href="cmn/mobile_admin.css">');
}else{
//PC
document.write('<link rel="stylesheet" href="cmn/admin.css">');
}
</script>
<script type="text/javascript" src="cmn/bbs.js"></script>
<title>$ttl</title>
</head>
<body>
<div id="head">
	<img src="$cf{cmnurl}/admin.png" alt="star" class="icon">
	:: $cf{bbs_title} 管理画面 ::
</div>
<div id="body">
EOM
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub cgi_err {
	my $err = shift;

	header("ERROR!");
	print <<EOM;
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p class="err">$err</p>
<hr width="350">
<form>
<input type="button" value="前画面に戻る" onclick="history.back()">
</form>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	header("完了");
	print <<EOM;
<div align="center" style="margin-top:3em;">
<hr width="350">
<p class="msg">$msg</p>
<hr width="350">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="submit" value="管理画面に戻る">
</form>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  文字カット for UTF-8
#  [quote] http://linkage.white-void.net/development/server/perl-utf8-strcut.html
#-----------------------------------------------------------
sub strcutbytes_utf8 {
	my ($src,$maxlen) = @_;
	$src =~ s/[\t\n]//g;
	$src =~ s|<br( /)?>|\n|g;
	
	my $srclen = length($src);
	my $srcpos = 0;
	while($srcpos < $srclen) {
		my $character = substr($src, $srcpos, 1);
		my $value = ord($character);
		if($value < 0x80) { # ASCII characters
			$srcpos++;
			next;
		}
		my $width = 6;
		$width = 5 if ($value < 0xFC);
		$width = 4 if ($value < 0xF8);
		$width = 3 if ($value < 0xF0);
		$width = 2 if ($value < 0xE0);
		my $nextpos = $srcpos + $width;
		last if($nextpos > $maxlen);
		last if($nextpos > $srclen); # sequence is incomplete
		$srcpos = $nextpos;
	}
	return substr($src, 0, $srcpos);
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}
#-----------------------------------------------------------
#  添付アップロード
#-----------------------------------------------------------
sub upload {
	my $no = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	# 拡張子取得
	my $ext = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : error("拡張子不明");
	$ext =~ tr/A-Z/a-z/;
	if ($ext eq '.jpeg') { $ext = '.jpg'; }

	# ファイルチェック
	check_upl($ext);

	# 添付ファイル定義
	my $upfile = "$cf{upldir}/$no$ext";

	# アップロード書き込み
	open(UP,"+> $upfile") or error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666, $upfile);

	# 画像サイズ取得
	my ($flg,$w,$h);
	if ($ext eq ".jpg") { ($w,$h) = &j_size($upfile); $flg++; }
	elsif ($ext eq ".gif") { ($w,$h) = &g_size($upfile); $flg++; }
	elsif ($ext eq ".png") { ($w,$h) = &p_size($upfile); $flg++; }

	# サムネイル化
	if ($flg && $cf{thumbnail}) {
		($w,$h) = &resize($w,$h);
		my $thumb = "$cf{upldir}/$no-s$ext";
		make_thumb($upfile,$thumb,$w,$h);
	}

	# 結果を返す
	return ($ext,$w,$h);
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  ファイルチェック
#-----------------------------------------------------------
sub check_upl {
	my ($ext) = @_;

	# mimeタイプ
	my $mime = $cgi->param_mime('upfile');

	my $flg;
	if ($cf{ok_gif}) {
		if ($mime =~ /^image\/gif$/i and $ext eq '.gif') { $flg++; }
	}
	if (!$flg and $cf{ok_jpeg}) {
		if ($mime =~ /^image\/p?jpe?g$/i and $ext eq '.jpg') { $flg++; }
	}
	if (!$flg and $cf{ok_pdf}) {
		if ($mime =~ /^application\/pdf$/i and $ext eq '.pdf') { $flg++; }
	}
	if (!$flg and $cf{ok_zip}) {
		if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ext eq '.zip') { $flg++; }
	}
	if (!$flg and $cf{ok_text}) {
		if ($mime =~ /^text\/plain$/i and $ext =~ /^\.te?xt$/) { $flg++; }
	}
	if (!$flg and $cf{ok_word}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ext eq '.doc') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ext eq '.docx') { $flg++; }
	}
	if (!$flg and $cf{ok_excel}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ext eq '.xls') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ext eq '.xlsx') { $flg++; }
	}
	if (!$flg and $cf{ok_ppt}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ext eq '.ppt') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ext eq '.pptx') { $flg++; }
	}
	if (!$flg and $cf{ok_mp3}) {
		if ($mime =~ /^audio\/mpeg$/i and $ext eq '.mp3') { $flg++; }
		elsif ($mime =~ /^audio\/mp3/i and $ext eq '.mp3') { $flg++; }
		elsif ($mime =~ /^audio\/mpg/i and $ext eq '.mp3') { $flg++; }
	}
	if (!$flg) { error('このファイルは取り扱いできません'); }
}
#-----------------------------------------------------------
#  著作権表記（削除・改変を禁ず）
#-----------------------------------------------------------
sub footer {
	my ($foot) = @_;
	
	my $copy = <<EOM;
<p style="margin-top:3em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
	- <a href="https://www.kent-web.com/" target="_top">$cf{version}</a> -<br />
	++ <a href="https://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my $mode = shift;
	
	print <<EOM;
<div class="back-btn">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
@{[ $mode ? qq|<input type="submit" name="$mode" value="&lt; 前画面">| : "" ]}
<input type="submit" value="&lt; メニュー">
</form>
</div>
EOM
}

