#!/usr/bin/perl

#┌─────────────────────────────────
#│ HONEY BOARD : honey.cgi - 2019/12/22
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Honey Board v6.1 PLUS : honey.cgi - 2019/12/23
#│  Edited byTRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# アクセス制限
passwd(%in) if ($cf{enter_pwd} ne '');

# 処理分岐
if ($in{res})  { reply_art(); }
if ($in{mode} eq 'expound') { expound_page(); }
if ($in{mode} eq 'form') { form_page(); }
if ($in{mode} eq 'note') { note_page(); }
if ($in{mode} eq 'icon') { icon_page(); }
if ($in{mode} eq 'album') { album(); }
if ($in{mode} eq 'border') { border_page(); }
if ($in{mode} eq 'past' && $cf{pastkey}) { past_log(); }
if ($in{del}) { dele_form(); }
if ($in{edit}) { edit_form(); }
bbs_list();

#-----------------------------------------------------------
#  記事表示
#-----------------------------------------------------------
sub bbs_list {
	# 検索
	if ($in{q} ne '') { find_page(); }

	# トピック表示
	if ($in{bbs} == 1) {
		bbs_topic();
	} else {
		$in{bbs} = 0;
	}

	# ページ数定義
	my $pg = $in{pg} || 0;

	# データ読み込み
	my ($i,@log,%res);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);

		++$i if (!$reno);
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pg_max});

		if ($reno) {
			$res{$reno} .= "$no<>$reno<>$date<>$name<>$eml<>$sub<>$ico<>$com<>$col<>$url<>$ex<>$w<>$h<>$col3<>$tube\0";
			next;
		}
		push(@log,$_);
	}
	close(IN);

	# 繰越ボタン作成
	my $pager = make_pager($i,$pg,'',$cf{max_thread});

	# クッキー取得
	my ($ck_nam,$ck_eml,$ck_url,$ck_ico,$ck_col,$ck_col3) = get_cookie();
	$ck_url ||= 'http://';

	# アイコン
	my %op;
	foreach (0 .. $#{$cf{icon}}) {
		my ($file,$name) = split(/,/, $cf{icon}->[$_]);
		if ($ck_ico == $_) {
			$op{icon} .= qq|<option value="$_" selected="selected">$name</option>\n|;
		} else {
			$op{icon} .= qq|<option value="$_">$name</option>\n|;
		}
	}

	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $ck_col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# # 枠色｛吹き出し｝
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($ck_col3 == $_) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# home or logoff
	my $home = $cf{enter_pwd} eq '' ? $cf{homepage} : "$cf{bbs_cgi}?mode=logoff";

	# カウンタ
	my $counter = bbs_count() if ($cf{counter});

	# テンプレート読込
	open(IN,"$cf{tmpldir}/bbs.html") or error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# 文字置き換え
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s/!homepage!/$home/g;
	$tmpl =~ s/<!-- pager -->/$pager/g;
	$tmpl =~ s/!fm_name!/$ck_nam/g;
	$tmpl =~ s/!fm_email!/$ck_eml/g;
	$tmpl =~ s/!fm_url!/$ck_url/g;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/<!-- op_([a-z]+) -->/$op{$1}/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!fm_sub!//g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s/!counter!/$counter/g;
	$tmpl =~ s/!bbs!/$in{bbs}/g;

	# テンプレート分割
	my ($head,$loop1,$loop2,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- boundary -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3,$4) : error("テンプレート不正");

	# 過去ログ
	if ($cf{pastkey} == 0) {
		$head =~ s/<!-- past_begin -->.+<!-- past_end -->//gs;
	}

	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# 記事展開
	my $i;
	foreach (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
		$eml &&= qq|<a href="mailto:$eml"><img src="$cf{imgurl}/mail.png" title="Mail" alt="" class="home"></a>| if ($eml);
		$com  = autolink($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{imgurl}/house.png" title="HOME" class="home" alt="" /></a>|;

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		if ($ex) {

			# 指定アイコン
			if (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{iconurl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}

			# 添付画像
			if ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{upldir}/$no-s$ex") {
					$op = qq|src="$cf{uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
				}

				# 画像はコメントの下
				if ($cf{imgpoint} == 1) {
					$com .= qq|<p><a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a></p>|;
				# 画像はコメントの左（廻り込み）
				} else {
					$com = qq|<a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a><span style="color:$col">$com</span><br clear="all">|;
				}
			}
		}

		$i++;
		my ($tmp,$rlp) = $i % 2 ? ($loop1,$loop2) : ($loop2,$loop1);

		$tmp =~ s|!num!|<b>$no</b>|g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!comment!/<span style="color:$col">$com<\/span>/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!color3!/$col3/g;
		$tmp =~ s|!icon!|<img src="$cf{imgurl}/$ico" alt="" />|g;
		$tmp =~ s/!mail!/$eml/g;
		$tmp =~ s/<!-- home -->/$url/g;
		$tmp =~ s|<!-- reply -->|<a href="$cf{bbs_cgi}?res=$no&amp;bbs=$in{bbs}"><img src="$cf{cmnurl}/reply.png" alt="返信" title="返信" class="icon"></a>|g;
		$tmp =~ s|<!-- dele -->|<a href="$cf{bbs_cgi}?del=$no"><img src="$cf{cmnurl}/bin-red-icon.png" alt="削除" title="削除" class="icon"></a>|g;
		$tmp =~ s|<!-- edit -->|<a href="$cf{bbs_cgi}?edit=$no"><img src="$cf{cmnurl}/document-edit.png" alt="修正" title="修正" class="icon"></a>|g;
		$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);

		print $tmp;

		# レス
		foreach my $res ( split(/\0/,$res{$no}) ) {
			my ($no,$reno,$date,$name,$eml,$sub,$ico,$com,$col,$url,$ex,$w,$h,$col3,$tube) = split(/<>/,$res);
			$eml &&= qq|<a href="mailto:$eml"><img src="$cf{imgurl}/mail.png" title="Mail" alt="" class="home"></a>| if ($eml);
			$com  = autolink($com) if ($cf{autolink});
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{imgurl}/house.png" title="HOME" class="home" alt="" /></a>|;

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		if ($ex) {

			# 指定アイコン
			if (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{iconurl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}

			# 添付画像
			if ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{upldir}/$no-s$ex") {
					$op = qq|src="$cf{uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
				}

				# 画像はコメントの下
				if ($cf{imgpoint} == 1) {
					$com .= qq|<p><a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a></p>|;
				# 画像はコメントの左（廻り込み）
				} else {
					$com = qq|<a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a><span style="color:$col">$com</spsn><br clear="all">|;
				}
			}
		}

			my $tmp = $rlp;
			$tmp =~ s/class="art-left"/class="resart-left" style="border-color: $cf{res_border}"/g;
			$tmp =~ s/class="art-right"/class="resart-right" style="border-color: $cf{res_border}"/g;
			$tmp =~ s/class="com-left"/class="rescom-left"/g;
			$tmp =~ s/class="com-right"/class="rescom-right"/g;
			$tmp =~ s/class="icon-left"/class="resicon-left"/g;
			$tmp =~ s/class="icon-right"/class="resicon-right"/g;
			$tmp =~ s/class="arrow-right"/class="resarrow-right" style="border-color: transparent transparent transparent $cf{res_arrow};"/g;
			$tmp =~ s/class="arrow-left"/class="resarrow-left" style="border-color: transparent $cf{res_arrow} transparent transparent;"/g;
			$tmp =~ s/id="container"/id="rescontainer"/g;
			$tmp =~ s|!icon!|<img src="$cf{imgurl}/$ico" alt="" />|g;
			$tmp =~ s|!num!|<b>$no</b>|g;
			$tmp =~ s|!sub!|$sub <span style="color:#941f57">(<b>$reno</b>)</span>|g;
			$tmp =~ s/!comment!/<span style="color:$col">$com<\/span>/g;
			$tmp =~ s/!date!/$date/g;
			$tmp =~ s/!name!/$name/g;
			#$tmp =~ s/!url!/$url/g;
			$tmp =~ s/!mail!/$eml/g;
			$tmp =~ s/!color3!/$col3/g;
			$tmp =~ s/<!-- home -->/$url/g;
			$tmp =~ s|<!-- dele -->|<a href="$cf{bbs_cgi}?del=$no"><img src="$cf{cmnurl}/bin-red-icon.png" alt="削除" title="削除" class="icon"></a>|g;
			$tmp =~ s|<!-- edit -->|<a href="$cf{bbs_cgi}?edit=$no"><img src="$cf{cmnurl}/document-edit.png" alt="修正" title="修正" class="icon"></a>|g;
			$tmp =~ s/<!-- res_youtube -->/$tube/ if ($tube);
			print $tmp;
		}
	}

	# フッター
	footer($foot);
}

#-----------------------------------------------------------
#  検索画面
#-----------------------------------------------------------
sub find_page {
	# ページ数定義
	my $pg = $in{pg} || 0;
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	
	# キーワード配列化
	$in{q} =~ s/　/ /g;
	my @q = split(/\s+/,$in{q});
	
	# データ読み込み
	my ($i,@log);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
		
		# 検索
		my $flg;
		for my $q (@q) {
			if ("$name $sub $com" =~ /^(?:$byte1|$byte2|$byte3|$byte4)*?\Q$q\E/i) {
				$flg++;
			} else {
				$flg = 0;
				last;
			}
		}
		next if (!$flg);
		
		# ヒット
		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_find});
		
		push(@log,$_);
	}
	close(IN);
	
	# ペイジャー
	my $pager = make_pager($i,$pg,$cf{max_find});
	
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('',<IN>);
	close(IN);
	
	# 文字置換え
	$tmpl =~ s/!(bbs_title|cmnurl|homepage|bbs_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon">|g;
	$tmpl =~ s/!(q|bbs)!/$in{$1}/g;
	$tmpl =~ s/!find-num!/$i/g;
	$tmpl =~ s/<!-- pager -->/$pager/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	
	# 分解
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3)
			: error("テンプレート不正");
	
	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;
	
	for (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="home"></a>|;
		my ($face,$fnam) = split(/,/,$cf{icon}[$ico]);
		
	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		if ($ex) {

			# 指定アイコン
			if (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{iconurl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}

			# 添付画像
			if ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{upldir}/$no-s$ex") {
					$op = qq|src="$cf{uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
				}

				# 画像はコメントの下
				if ($cf{imgpoint} == 1) {
					$com .= qq|<p><a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a></p>|;
				# 画像はコメントの左（廻り込み）
				} else {
					$com = qq|<a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a><span style="color:$col">$com</span><br clear="all">|;
				}
			}
		}

		my $tmp = $loop;
		$tmp =~ s|!icon!|<img src="$cf{imgurl}/$ico" alt="" />|g;
		$tmp =~ s/!color3!/$col3/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s|!comment!|<span style="color:$col">$com</span>|;
		$tmp =~ s/!name!/$name/;
		$tmp =~ s/!date!/$date/;
		$tmp =~ s/!mail!/$eml/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
		
		print $tmp;
	}
	
	print $foot;
	exit;
}

#-----------------------------------------------------------
#  投稿フォーム
#-----------------------------------------------------------
sub form_page {
	if ($in{bbs} eq '') { $in{bbs} = 0; }

	# クッキー取得
	my ($ck_nam,$ck_eml,$ck_url,$ck_ico,$ck_col,$ck_col3) = get_cookie();
	$ck_url ||= 'http://';

	# アイコン
	my %op;
	foreach (0 .. $#{$cf{icon}}) {
		my ($file,$name) = split(/,/, $cf{icon}->[$_]);
		if ($ck_ico == $_) {
			$op{icon} .= qq|<option value="$_" selected>$name\n|;
		} else {
			$op{icon} .= qq|<option value="$_">$name\n|;
		}
	}

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $ck_col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">●</span>\n|;
	}

	# # 枠色｛吹き出し｝
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($ck_col3 == $_) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# 画像認証作成
	my ($str_plain,$str_crypt,$regikey,$JavaScript);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt, $regikey, $JavaScript) = cap::make( $cf{captcha_key}, $cf{cap_len} );
		$JavaScript=&mkJavaScript($regikey,'myFORM') if($cf{cap_len} == 3);
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s/!fm_name!/$ck_nam/g;
	$tmpl =~ s/!fm_email!/$ck_eml/g;
	$tmpl =~ s/!fm_url!/$ck_url/g;
	$tmpl =~ s/<!-- op_([a-z]+) -->/$op{$1}/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!fm_sub!//g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s/!bbs!/$in{bbs}/g;
	$tmpl =~ s/!res!/$in{res}/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  削除フォーム
#-----------------------------------------------------------
sub dele_form {
	$in{del} =~ s/\D//g;
	
	my ($flg,$log);
	open(DAT,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<DAT>) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
		
		if ($in{del} == $no) {
			$log = $_;
			next;
		}
		if ($log && $in{del} == $reno) {
			$flg++;
			last;
		}
	}
	close(DAT);
	
	# レス有り
	if ($flg) { error("この記事は返信記事があるため削除できません"); }
	
	my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/,$log);
	if ($pw eq '') { error("この記事は削除キーが設定されていません"); }
	
	open(IN,"$cf{tmpldir}/dele.html") or error("open err: dele.html");
	my $tmpl = join('',<IN>);
	close(IN);
	
	$tmpl =~ s/!(bbs_title|cmnurl|bbs_cgi|post_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s/!del!/$in{del}/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!date!/$date/g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  編集パスワードフォーム
#-----------------------------------------------------------
sub edit_form {

	$in{edit} =~ s/\D//g;

	# 記事
	my ($name,$pwd);
	open(IN,"$cf{logfile}") or cgi_err("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3) = split(/<>/);

	if ($in{edit} == $no) {
		$name = $name;
		$pwd = $pw;
		last;
		}
	}
	close(IN);

	# パスワード未設定
	error("この記事はパスワード未設定のため編集できません") if ($pwd eq '');

	my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com  = autolink($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{imgurl}/house.png" class="home" alt="" /></a>|;

		if (length($com) > 135) { $com = substr($com,0,145); $com .= '.....(略)'; }

		# 添付あり
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'">$no$ex</a> (<b style="color:#FF9966">$size</b>)</div>|;
			}

	open(IN,"$cf{tmpldir}/gate.html") or &error("open err: gate.html");
	my $tmpl = join('', <IN>);
	close(IN);

	if ($in{bbs} == 1) {
		$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}?bbs=1/g;
		$tmpl =~ s|<!-- hidden -->|<input type="hidden" name="bbs" value="1" />|;
	} else {
		$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	}

	# 文字置換
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!edit!/$no/g;
	$tmpl =~ s/!pwd!/$pw/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s/!color3!/$col3/g;
	$tmpl =~ s/!comment!/<span style="color:$col">$com<\/span>/g;
	$tmpl =~ s/!url!/$url/g;
	$tmpl =~ s/class="art"/class="res" style="border-color: $cf{res_border}"/g;
	$tmpl =~ s/<!-- clip -->/$clip/;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッター
	footer();

	exit;
}

#-----------------------------------------------------------
#  YouTube貼付方法
#-----------------------------------------------------------
sub expound_page {

	open(IN,"$cf{tmpldir}/expound.html  ") or error("open err: expound.html  ");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッター
	footer();

	exit;
}

#-----------------------------------------------------------
#  返信フォーム
#-----------------------------------------------------------
sub reply_art {

	# データ読み込み
	my ($resub,@log,@res);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);

		if ($in{res} == $no) {
			push(@log,$_);

			# タイトル名
			if ($sub =~ /^Re:/) {
				$resub = $sub;
			} else {
				$resub = "Re: $sub";
			}
		} elsif ($in{res} == $reno) {
			push(@res,$_);
		}
	}
	close(IN);

	# クッキー取得
	my ($ck_nam,$ck_eml,$ck_url,$ck_ico,$ck_col,$ck_col3) = get_cookie();
	$ck_url ||= 'http://';

	# アイコン
	my %op;
	foreach (0 .. $#{$cf{icon}}) {
		my ($file,$name) = split(/,/, $cf{icon}->[$_]);
		if ($ck_ico == $_) {
			$op{icon} .= qq|<option value="$_" selected="selected">$name</option>\n|;
		} else {
			$op{icon} .= qq|<option value="$_">$name</option>\n|;
		}
	}

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $ck_col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# # 枠色｛吹き出し｝
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($ck_col3 == $_) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# テンプレート読込
	open(IN,"$cf{tmpldir}/reply.html") or error("open err: reply.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make( $cf{captcha_key}, $cf{cap_len} );
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# 文字置き換え
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s/!page_btn!//g;
	$tmpl =~ s/!fm_name!/$ck_nam/g;
	$tmpl =~ s/!fm_email!/$ck_eml/g;
	$tmpl =~ s/!fm_url!/$ck_url/g;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/<!-- op_([a-z]+) -->/$op{$1}/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!fm_sub!/$resub/g;
	$tmpl =~ s/!bbs!/$in{bbs}/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s|<!-- res_num -->|<input type="hidden" name="reno" value="$in{res}" />|;

	# テンプレート分割
	my ($head,$loop1,$loop2,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- boundary -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3,$4) : error("テンプレート不正");

	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
		#$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$eml &&= qq|<a href="mailto:$eml"><img src="$cf{imgurl}/mail.png" title="Mail" alt="" class="home"></a>| if ($eml);
		$com  = autolink($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{imgurl}/house.png" title="HOME" class="home" alt="" /></a>|;

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		if ($ex) {

			# 指定アイコン
			if (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{iconurl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}

			# 添付画像
			if ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{upldir}/$no-s$ex") {
					$op = qq|src="$cf{uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
				}

				# 画像はコメントの下
				if ($cf{imgpoint} == 1) {
					$com .= qq|<p><a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a></p>|;
				# 画像はコメントの左（廻り込み）
				} else {
					$com = qq|<a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a><span style="color:$col">$com</spsn><br clear="all">|;
				}
			}
		}

		my $tmp = $loop1;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!comment!/<span style="color:$col">$com<\/span>/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s|!icon!|<img src="$cf{imgurl}/$ico" alt="" />|g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!mail!/$eml/g;
		$tmp =~ s/!color3!/$col3/g;
		$tmp =~ s/<!-- home -->/$url/g;
		$tmp =~ s|<!-- dele -->|<a href="$cf{bbs_cgi}?del=$no"><img src="$cf{cmnurl}/bin-red-icon.png" alt="削除" title="削除" class="icon"></a>|g;
		$tmp =~ s|<!-- edit -->|<a href="$cf{bbs_cgi}?edit=$no"><img src="$cf{cmnurl}/document-edit.png" alt="修正" title="修正" class="icon"></a>|g;
		$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
		print $tmp;
	}
	foreach (@res) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
			#$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
			$eml &&= qq|<a href="mailto:$eml"><img src="$cf{imgurl}/mail.png" title="Mail" alt="" class="home"></a>| if ($eml);
			$com  = autolink($com) if ($cf{autolink});
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{imgurl}/house.png" title="HOME" class="home" alt="" /></a>|;

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		if ($ex) {

			# 指定アイコン
			if (defined($cf{icons}{$ex})) {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<div class="clip">添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{iconurl}/$cf{icons}{$ex}" alt="" class="icon" /></a> (<b style="color:#00a1e9">$size</b>)</div>|;
			}

			# 添付画像
			if ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{upldir}/$no-s$ex") {
					$op = qq|src="$cf{uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
				}

				# 画像はコメントの下
				if ($cf{imgpoint} == 1) {
					$com .= qq|<p><a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a></p>|;
				# 画像はコメントの左（廻り込み）
				} else {
					$com = qq|<a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'"><div class="snapshot"><img $op border="0" class="baseImage"><img src="$cf{img_ico}" width="24" height="24" class="coverImage"></div></a><span style="color:$col">$com</spsn><br clear="all">|;
				}
			}
		}

		my $tmp = $loop2;
		$tmp =~ s/class="art-left"/class="resart-left" style="border-color: $cf{res_border}"/g;
		$tmp =~ s/class="art-right"/class="resart-right" style="border-color: $cf{res_border}"/g;
		$tmp =~ s/class="com-left"/class="rescom-left"/g;
		$tmp =~ s/class="com-right"/class="rescom-right"/g;
		$tmp =~ s/class="icon-left"/class="resicon-left"/g;
		$tmp =~ s/class="icon-right"/class="resicon-right"/g;
		$tmp =~ s/class="arrow-right"/class="resarrow-right" style="border-color: transparent transparent transparent $cf{res_arrow};"/g;
		$tmp =~ s/class="arrow-left"/class="resarrow-left" style="border-color: transparent $cf{res_arrow} transparent transparent;"/g;
		$tmp =~ s/id="container"/id="rescontainer"/g;
		$tmp =~ s|!icon!|<img src="$cf{imgurl}/$ico" alt="" />|g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s|!sub!|$sub <span style="color:#941f57">(<b>$reno</b>)</span>|g;
		$tmp =~ s/!comment!/<span style="color:$col">$com<\/span>/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!mail!/$eml/g;
		$tmp =~ s/<!-- home -->/$url/g;
		$tmp =~ s|<!-- dele -->|<a href="$cf{bbs_cgi}?del=$no"><img src="$cf{cmnurl}/bin-red-icon.png" alt="削除" title="削除" class="icon"></a>|g;
		$tmp =~ s|<!-- edit -->|<a href="$cf{bbs_cgi}?edit=$no"><img src="$cf{cmnurl}/document-edit.png" alt="修正" title="修正" class="icon"></a>|g;
		$tmp =~ s/<!-- res_youtube -->/$tube/ if ($tube);
		print $tmp;
	}

	# フッター
	footer($foot);
}

#-----------------------------------------------------------
#  ボーダーカラー・サンプル
#-----------------------------------------------------------
sub border_page {

	# テンプレート認識
	open(IN,"$cf{tmpldir}/border_color.html") or &error("open err: border_color.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# テンプレート分割
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		&error("テンプレートが不正です");
	}

	# 文字置換
	foreach ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!version!/$cf{version}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	foreach (0 .. $#col3) {

		my $tmp = $loop;
		$tmp =~ s/!name!/$col4[$_]/g;
		$tmp =~ s|!color_b!|<div class="art-left2" style="border-color:$col3[$_]">Speech balloon<br />Sample</div><div class="arrow-left2" style="border-color: transparent $col3[$_] transparent transparent;"></div>|g;
		print $tmp;
	}

	# フッタ
	footer($foot);
	exit;
}

#-----------------------------------------------------------
#  アルバム機能
#-----------------------------------------------------------
sub album {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/album.html") or error("open err: album.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!bbs!/$in{bbs}/g;

	if ($in{bbs} == 1) {
		$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}?bbs=1/g;
	} else {
		$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	}

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# データ読み込み
	my ($i,@img);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3) = split(/<>/);
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 画像データ収集
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $pager = make_pager($i,$pg,'&mode=album',$cf{max_albums});

	# 文字置換
	for ($head, $foot) {
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/!page_btn!/$pager/g;
		s/!bbs_title!/$cf{bbs_title}/g;

	# 過去ログ
		s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$ex,$w,$h,$sub)/eg;
		$tmp =~ s/!caption!/$sub/g;

		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  繰越ボタン作成 (アルバム)
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg,$stat,$max) = @_;
	$max ||= 5;

	# ページ繰越定義
	my $next = $pg + $max;
	my $back = $pg - $max;

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $max;
			$z -= $max;

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	# 結果を返す
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  留意事項表示
#-----------------------------------------------------------
sub note_page {
	# 許可拡張子（表示用）
	my $ftype = ext_file();

	open(IN,"$cf{tmpldir}/note.html") or error("open err: note.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!filetype!/$ftype/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッター
	footer();

	exit;
}

#-----------------------------------------------------------
#  アイコン一覧
#-----------------------------------------------------------
sub icon_page {
	# 画像サイズ再定義
	$cf{max_img_w} = 40;
	$cf{max_img_h} = 40;

	# テンプレート認識
	open(IN,"$cf{tmpldir}/icon.html") or error("open err: icon.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- photo_begin -->(.+)<!-- photo_end -->(.+)/s
			? ($1,$2,$3) : error("テンプレート不正");

	# 文字置換
	foreach ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (0 .. $#{$cf{icon}}) {
		my ($ico,$cap) = split(/,/,$cf{icon}->[$_]);

		my $tmp = $loop;
		$tmp =~ s|!image!|<img src="$cf{imgurl}/$ico" alt="" />|g;
		$tmp =~ s/!caption!/$cap/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
	exit;
}

#-----------------------------------------------------------
#  トピックス画面
#-----------------------------------------------------------
sub bbs_topic {

	# クッキー取得
	my ($ck_nam,$ck_eml,$ck_url,$ck_ico,$ck_col,$ck_col3) = get_cookie();
	$ck_url ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $ck_col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# アイコン
	my %op;
	foreach (0 .. $#{$cf{icon}}) {
		my ($file,$name) = split(/,/, $cf{icon}->[$_]);
		if ($ck_ico == $_) {
			$op{icon} .= qq|<option value="$_" selected>$name</option>\n|;
		} else {
			$op{icon} .= qq|<option value="$_">$name</option>\n|;
		}
	}

	# # 枠色｛吹き出し｝
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($ck_col3 == $_) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ページ数
	my $pg = $in{pg} || 0;

	# データ認識
	my ($i,@log,%res,%last);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while(<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$ex,$w,$h,$col3,$tube) = split(/<>/);

		if (!$reno) { $i++; }
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_topics});

		if ($reno) { 
			$res{$reno}++;
			$last{$reno} = "<p align=\"right\">$date<br />$name</p>";
		} else {
			$last{$no} = "<p align=\"right\">$date<br />$name</p>";
		}

		push(@log,$_) if (!$reno);
	}
	close(IN);

	# ペイジャー
	my $pager = make_pager($i,$pg,'&amp;bbs=1',$cf{max_topics});

	# カウンタ
	my $counter = bbs_count() if ($cf{counter});

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/topic.html") or error("open err: topic.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$tmpl =~ s/<!-- captcha -->.+<!-- captcha -->//s;
	}

	# 文字置換え
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!page_btn!/$pager/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!fm_sub!//g;
	$tmpl =~ s/!fm_name!/$ck_nam/;
	$tmpl =~ s/!fm_email!/$ck_eml/;
	$tmpl =~ s/!fm_url!/$ck_url/;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/<!-- op_([a-z]+) -->/$op{$1}/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s/\?mode=form/?mode=form&amp;bbs=1/g;
	$tmpl =~ s/\?mode=find/?mode=find&amp;bbs=1/g;
	$tmpl =~ s/\?mode=album/?mode=album&amp;bbs=1/g;
	$tmpl =~ s/\?mode=memory/?mode=memory&amp;bbs=1/g;
	$tmpl =~ s/\?mode=past/?mode=past&amp;bbs=1/g;
	$tmpl =~ s/!counter!/$counter/g;
	$tmpl =~ s/!q!/$in{q}/g;

	# 分解
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3)
			: error("テンプレート不正");

	# 過去ログ
	if ($cf{pastkey} == 0) {
		$head =~ s/<!-- past_begin -->.+<!-- past_end -->//gs;
	}

	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# 親記事展開
	foreach (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$ex,$w,$h,$col3,$tube) = split(/<>/);

		if ($res{$no} eq '') { $res{$no} = 0; }

		my $tmp = $loop;
		$tmp =~ s/!topi-num!/$no/g;
		$tmp =~ s|!topi-ttl!|<a href="$cf{bbs_cgi}?res=$no&amp;bbs=1">$sub</a>|g;
		$tmp =~ s/!topi-nam!/$name/g;
		$tmp =~ s/!topi-res!/$res{$no}/g;
		$tmp =~ s/!topi-last!/$last{$no}/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  過去ログ画面
#-----------------------------------------------------------
sub past_log {
	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# プルダウンタグ作成
	my $op_pno;
	for ( my $i = $pastnum; $i > 0; $i-- ) {
		$i = sprintf("%04d", $i);

		if ($in{pno} == $i) {
			$op_pno .= qq|<option value="$i" selected>$i\n|;
		} else {
			$op_pno .= qq|<option value="$i">$i\n|;
		}
	}

	# ページ数
	my $pg = $in{pg} || 0;

	# 初期化
	my ($hit,$page_btn,$hit,@log,%res);

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# ワード検索
	if ($in{find} && $in{word} ne '') {
		# 検索
		($hit,@log) = search($file,$in{list},'past');

		# 結果
		$page_btn = "検索結果：<b>$hit</b>件 &nbsp;&nbsp;" . pgbtn_old($hit,$in{pno},$pg,$in{list},'find');

	# ログ一覧
	} else {
		my $pg_max = $cf{max_thread};

		# 過去ログオープン
		my @res;
		my $i = 0;
		open(IN,"$file") or error("open err: $file");
		while(<IN>) {
			my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
			++$i if ($reno eq '');
			next if ($i < $pg + 1);
			next if ($i > $pg + $pg_max);

			if ($reno) {
				$res{$reno} .= "$no<>$reno<>$date<>$name<>$eml<>$sub<>$ico<>$ico2<>$com<>$col<>$url<>$host<>$pw<>$ex<>$w<>$h<>$col3<>$tube\0";
				next;
			}
			push(@log,$_);
		}
		close(IN);

		# 繰越ボタン作成
		$page_btn = pgbtn_old($i,$in{pno},$pg,$pg_max);
	}

	# プルダウン作成（検索条件）
	my %op = make_op();

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/past.html") or error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# 分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3) : error('テンプレート不正');

	if ($in{change}) { $in{word} = ''; }

	my @col = split(/\s+/,$cf{colors});

	# 文字置換
	for ($head, $foot) {
		s/!past_num!/$in{pno}/g;
	if ($in{bbs} == 1) {
		s/!bbs_cgi!/$cf{bbs_cgi}?bbs=1/g;
		s|<!-- hidden -->|<input type="hidden" name="bbs" value="1" />|;
	} else {
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
	}
		#s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/<!-- op_pno -->/$op_pno/g;
		s/<!-- op_(\w+) -->/$op{$1}/g;
		s/!word!/$in{word}/g;
		s/!page_btn!/$page_btn/g;
		s/!bbs_title!/$cf{bbs_title}/g;
	}

	# 画面表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# ループ部
	foreach  (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3,$tube) = split(/<>/);
		#$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$eml &&= qq|<a href="mailto:$eml"><img src="$cf{imgurl}/mail.png" title="Mail" alt="" class="home"></a>| if ($eml);
		$com  = autolink($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{imgurl}/house.png" title="HOME" class="home" alt="" /></a>|;

		# 添付あり
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
				$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'">$no$ex</a> (<b style="color:#FF9966">$size</b>)</div>|;
			}

		# レス
		my $res;
		foreach my $log ( split(/\0/,$res{$no}) ) {
			my ($no,$reno,$date,$name,$eml,$sub,$ico,$ico2,$com,$col,$url,$host,$pw,$ex,$w,$h,$col3) = split(/<>/, $log);
			#$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
			$eml &&= qq|<a href="mailto:$eml"><img src="$cf{imgurl}/mail.png" title="Mail" alt="" class="home"></a>| if ($eml);
			$com  = autolink($com) if ($cf{autolink});
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{imgurl}/house.png" title="HOME" class="home" alt="" /></a>|;

			# 添付あり
			my $clip;
			if ($ex) {
				my $size = get_size("$cf{upldir}/$no$ex");
					$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'">$no$ex</a> (<b style="color:#FF9966">$size</b>)</div>|;
				}

			my $tmp = $loop;
			$tmp =~ s/!sub!/$sub/g;
			$tmp =~ s/!date!/$date/g;
			$tmp =~ s/!name!/$name/g;
			$tmp =~ s/!home!/$url/g;
			$tmp =~ s/!mail!/$eml/g;
			$tmp =~ s/!num!/$no/g;
			$tmp =~ s/!color3!/$col3/g;
			$tmp =~ s/!comment!/<span style="color:$col">$com<\/span>/g;
			$tmp =~ s|!icon!|<img src="$cf{imgurl}/$ico" class="image" alt="" />|g;
			$tmp =~ s/<!-- r_ext -->/$clip/;
			$tmp =~ s/class="art"/class="res" style="border-color: $cf{res_border}"/g;
			$res .= $tmp;
		}

		my $tmp = $loop;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!mail!/$eml/g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!color3!/$col3/g;
		$tmp =~ s/!comment!/<span style="color:$col">$com<\/span>/g;
		$tmp =~ s|!icon!|<img src="$cf{imgurl}/$ico" class="image" alt="" />|g;
		$tmp =~ s/<!-- ext -->/$clip/;
		$tmp =~ s|<!-- res -->|$res|g if ($res);
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  繰越ボタン作成 [ 過去ログ ]
#-----------------------------------------------------------
sub pgbtn_old {
	my ($i,$pno,$pg,$stat) = @_;

	# ページ繰越定義
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{max_thread};
	my $back = $pg - $cf{max_thread};

	my $link;
	if ($stat eq 'past') {
		my $wd = url_enc($in{word});
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno&amp;find=1&amp;word=$wd";
	} else {
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno";
	}

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>\n!);
			} else {
				push(@pg,qq!<li><a href="$link&amp;pg=$y">$x</a></li>\n!);
			}
			$x++;
			$y += $cf{max_thread};
			$z -= $cf{max_thread};
			
			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$link&amp;pg=$back">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$link&amp;pg=$next">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  プルダウン作成 [ 検索条件 ]
#-----------------------------------------------------------
sub make_op {
	my %op;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op{cond} .= qq|<option value="$_" selected>$cond{$_}\n|;
		} else {
			$op{cond} .= qq|<option value="$_">$cond{$_}\n|;
		}
	}
	for ( my $i = 10; $i <= 30; $i += 5 ) {
		if ($in{list} == $i) {
			$op{list} .= qq|<option value="$i" selected>$i件\n|;
		} else {
			$op{list} .= qq|<option value="$i">$i件\n|;
		}
	}
	return %op;
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	# クッキー取得
	my $cook = $ENV{HTTP_COOKIE};

	# 該当IDを取り出す
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLデコード
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:2.5em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
- <a href="https://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
++ <a href="https://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  繰越ボタン作成
#-----------------------------------------------------------
sub make_pager {
	my ($i,$pg,$stat,$max) = @_;
	$max ||= 5;

	# 引数
	my $stat = "&amp;bbs=$in{bbs}";
	if ($in{q} ne '') {
		my $q = url_enc($in{q});
		$stat .= "&amp;q=$q";
	}

	# ページ繰越定義
	my $next = $pg + $max;
	my $back = $pg - $max;

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $max;
			$z -= $max;

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  カウンタ処理
#-----------------------------------------------------------
sub bbs_count {
	# IP取得
	my $addr = $ENV{REMOTE_ADDR};

	# 閲覧時のみカウントアップ
	my $cntup = $in{mode} eq '' ? 1 : 0;

	# カウントファイルを読みこみ
	open(LOG,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
	eval "flock(LOG, 2);";
	my $count = <LOG>;

	my $flg;

	# IPチェックとログ破損チェック
	my ($cnt, $ip) = split(/:/, $count);

	if ($cf{ip_check}) {
		#if ($addr eq $ip || $cnt eq "") { $cntup = 0; }
		if ($addr eq $ip) { $flg = 1; }
	}

	# カウントアップ
	#if ($cntup) {
	if (!$flg) {
		$cnt++;
		seek(LOG, 0, 0);
		print LOG "$cnt:$addr";
		truncate(LOG, tell(LOG));
	}
	close(LOG);

	# 桁数調整
	while(length($cnt) < $cf{mini_fig}) { $cnt = '0' . $cnt; }
	my @cnts = split(//,$cnt);

	# GIFカウンタ表示
	my $counter;
	if ($cf{counter} == 2) {
		foreach (0 .. $#cnts) {
			$counter .= qq|<img src="$cf{gif_path}/$cnts[$_].gif\" alt="$cnts[$_]" />|;
		}

	# テキストカウンタ表示
	} else {
		$counter = qq|<span style="color:$cf{cntcol}">$cnt</span>\n|;
	}
	return $counter;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub autolink {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  取り扱いファイル
#-----------------------------------------------------------
sub ext_file {
	my $ext;
	foreach ( keys %cf ) {
		next if ($_ !~ /^ok_(\w+)/);
		my $file = $1;
		next if (!$cf{$_});

		$file =~ tr/a-z/A-Z/;
		$ext .= "$file, ";
	}
	$ext =~ s/, $//;

	return $ext;
}

#-----------------------------------------------------------
#  画像表示
#-----------------------------------------------------------
sub image {
	my ($no,$ex,$w,$h,$sub) = @_;

	my $image;
	if (-f "$cf{upldir}/$no-s$ex") {
		$image = qq|<img src="$cf{upldir}/$no-s$ex" border="0">|;

	} else {
		($w,$h) = resize($w,$h);
		$image = qq|<img src="$cf{upldir}/$no$ex" width="$w" height="$h" border="0">|;
	}
	return qq|<a href="$cf{upldir}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group="honey-set" data-lightview-group-options="skin: 'mac'">$image</a>\n|;
}

#-----------------------------------------------------------
#  URLエンコード
#-----------------------------------------------------------
sub url_enc {
	local($_) = @_;
	
	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}
