# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ HONEY BOARD : init.cgi - 2019/12/22
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'Honey Board v6.1';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトはフリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Honey Board v6.1 PLUS : init.cgi -  2019/12/23
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

#===========================================================
# ■ 基本設定
#===========================================================

# 管理者専用アイコン用パスワード
$cf{password} = '0123';

# パスワード制限をする場合入室パスワード設定
# → 空欄の場合はパスワード制限なし
$cf{enter_pwd} = '0123';

# パスワード制限時のセッションの許容時間（分単位）
# → 入室後からアクセス可能時間
$cf{sestime} = 60;

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 0;

# YouTubeを表示する
$cf{tube} = 1;

# Youtubeアイコン
$cf{tube_ico} = "./cmn/tube_icon.png";

# イメージ拡大アイコン
$cf{img_ico} = "./cmn/link.png";

# タイトル名
$cf{bbs_title} = "Honey Board v6.1 PLUS";

# 本体プログラムURL
$cf{bbs_cgi} = './honey.cgi';

# 投稿受理プログラムURL
$cf{post_cgi} = './post.cgi';

# 管理プログラムURL
$cf{admin_cgi} = './admin.cgi';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# ログファイル
$cf{logfile} = './data/log.cgi';

# セッションファイル【サーバパス】
$cf{sesfile} = './data/ses.cgi';

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = './tmpl';

# アップロードディレクトリ【サーバパス】
$cf{upldir} = "./upl";

# アップロードディレクトリ【URLパス】
$cf{uplurl} = "./upl";

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 210;	# 横幅
$cf{max_img_h} = 180;	# 縦幅

# 画像と記事の位置
#  1 : 画像が下。記事は画像の上に表示。
#  2 : 画像が左。記事は右から回り込む。
$cf{imgpoint} = 2;

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 1;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_png}   = 1;  # PNG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 0;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 1;  # PDF
$cf{ok_mp3}   = 1;  # mp3
$cf{ok_mp4}   = 1;  # MP4

# 最大記事数（親記事でカウントする。これを超える記事は古い順に削除）
# # 過去ログ生成 [$cf{pastkey} = 1;]の場合は過去ログへ移動
$cf{maxlog} = 200;

# 戻り先【URLパス】
$cf{homepage} = "../index.html";

# 画像ディレクトリ
$cf{imgurl} = './cmn/img';

# アイコンディレクトリ【URLパス】
$cf{iconurl} = './cmn/icon';

# アイコン画像【URLパス】
$cf{ico_edit} = "./cmn/icon/edit.gif";
$cf{ico_clip} = "./cmn/icon/blue_clip.gif";
$cf{ico_img} = "./cmn/icon/pictures.gif";

# アイコン定義
# → 拡張子とファイル名のペア
$cf{icons} = {
	'.pdf'  => 'pdf.png',
	'.doc'  => 'word.png',
	'.docx' => 'Word-icon.png',
	'.xls'  => 'excel.png',
	'.xlsx' => 'Excel-icon.png',
	'.ppt'  => 'ppt.png',
	'.pptx' => 'powerpoint.png',
	'.txt'  => 'text.png',
	'.zip'  => 'zip.png',
	'.mp3'  => 'mp3.png',
	'.mp4'  => 'mp4.png',
	};

# 記事の更新は method=POST 限定 (0=no 1=yes)
$cf{postonly} = 1;

# URLの自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# １ページあたりの親記事表示数
# → 順に、スレッド表示、トピック表示、アルバム表示、検索結果
$cf{pg_max}     = 5;
$cf{max_thread} = 5;
$cf{max_topics} = 5;
$cf{max_albums} = 5;
$cf{max_find} = 10;

# 記事 [タイトル] 部の長さ (全角文字換算)
$cf{sub_len} = 50;

# レスがついたらツリー毎トップへ移動 (0=no 1=yes)
$cf{top_sort} = 1;

# 投稿があるとメール通知する (sendmail必須)
# 0 : 通知しない
# 1 : 通知する
$cf{mailing} = 0;

# メールアドレス(メール通知する時)
$cf{mailto} = 'xxx@xxx.xxx';

# sendmailパス（メール通知する時）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# 文字色の設定
# →　スペースで区切る
$cf{colors} = '#0075c2 #398ED9 #4753a2 #6c2463 #a688bd #98605e #ea5550 #da81b2 #e3acae #ffdc00 #f39800 #79c06e #417038 #C0C0C0 #666666 #000000';

# 枠色の設定（半角スペースで区切る）
$cf{colors_b} = '#f7b977 #ee7800 #e5a323 #79c06e #417038 #5f6527 #ffdc00 #f39800 #98605e #941f57 #ea5550 #ef857d #47266e #a688bd #6c2463 #da81b2 #f3a68c #e95464 #e3acae #7a99cf #a2c2e6 #8d93c8 #0073a8 #898989 #626063';

$cf{colors_b2}= 'アプリコット オレンジ パンプキン スペアミント スピナッチグリーン オリーブグリーン ジョンブリアン マリーゴールド ココアブラウン クラレット レッド コーラルレッド ディープロイヤルパープル ラベンダーモーブ プラム オーキッドピンク サーモンピンク ローズ ピンクアーモンド ヒヤシンスブルー ベイビーブルー ウイスタリア エジプシャンブルー バトルシップグレイ スレートグレイ';

# 返信枠色
$cf{res_border} = '#e6e4e3';

# 返信arrow色
$cf{res_arrow} = '#e6e4e3';

# アイコン
# → 「ファイル名」とその「キャラクタ名」をコンマで区切る
$cf{icon} = [
	"boy1.gif,少年1",
	"boy2.gif,少年2",
	"seinen.gif,青年",
	"girl1.gif,少女1",
	"girl2.gif,少女2",
	"ol1.gif,OL風1",
	"ol2.gif,OL風2",
	"china.gif,中国風",
	"cook.gif,コック風",
	"piero.gif,ピエロ",
	"dog.gif,子犬",
	"cat.gif,子猫",
	"mouse.gif,子ネズミ",
	"pig.gif,子ブタ",
	"hiyoko.gif,ヒヨコ",
	"flog.gif,カエル",
	];

# 管理者専用アイコン機能 (0=no 1=yes)
# (使い方) 記事投稿時に「管理者アイコン」を選択し暗証キーに「管理者専用アイコン用パスワード」を入力して下さい。
$cf{my_icon} = 1;

# 管理者専用アイコンの「ファイル名」を指定
$cf{my_gif}  = 'admin.gif';

# ミニカウンタの設置
# → 0=no 1=テキスト 2=画像
$cf{counter} = 1;

# IPアドレスの二重カウントチェック
# 0 : チェックしない
# 1 : チェックする
$cf{ip_check} = 0;

# ミニカウンタの桁数
$cf{mini_fig} = 6;

# テキストのとき：ミニカウンタの色
$cf{cntcol} = "#fff";

# 画像のとき：画像ディレクトリを指定【URLパス】
# → 最後は必ず / で閉じない
$cf{gif_path} = "./img";

# カウンタファイル【サーバパス】
$cf{cntfile} = './data/count.dat';

# 制限投稿間隔（秒数）
$cf{wait} = 0;

# 禁止ワード
# → 投稿時禁止するワードをコンマで区切る
$cf{no_wd} = 'コピー';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
$cf{jp_wd} = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 2;

# １回当りの最大投稿サイズ (bytes)
$cf{maxdata} = 512000000;

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# アクセス制限（半角スペースで区切る、アスタリスク可）
#  → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
#  → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '106.154.158.187';

# クッキーID名（特に変更しなくてよい）
# → クッキー保存名
$cf{cookie_id} = "honey";
$cf{cookie_id3} = "honey_pwd";

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# -------------------------------------------------------------- #
# [ 以下は「過去ログ」機能を使用する場合の設定 ]
#
# 過去ログ生成
# → 0=no 1=yes
$cf{pastkey} = 1;

# 過去ログ用NOファイル【サーバパス】
$cf{nofile}  = './data/pastno.dat';

# 過去ログのディレクトリ【サーバパス】
# → パスの最後に / をつけない
$cf{pastdir} = './data/past';

# 過去ログ１ファイルの行数
# → この行数を超えると次ページを自動生成します
$cf{pastmax} = 600;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能（スパム対策）を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 1;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'capt_honeybbs';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "dice.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# アイコン追加
push(@{$cf{icon}},"$cf{my_gif},管理者用") if ($cf{my_icon});

# 設定値を返す
sub set_init { return %cf; }

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if ($_ ne 'upfile') {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行処理
			$val =~ s/\r\n/<br>/g;
			$val =~ s/\r/<br>/g;
			$val =~ s/\n/<br>/g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  パスワード制限
#-----------------------------------------------------------
sub passwd {
	my %in = @_;

	# 入室フォーム指定のとき
	if ($in{mode} eq 'enter') { &pwd_form; }

	# 時間取得
	my $now = time;

	# ログインのとき
	if ($in{login}) {
		# 認証
		if ($in{pw} ne $cf{enter_pwd}) { &error("認証できません"); }

		# セッション発行
		my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z', '_');
		my $ses;
		srand;
		for (1 .. 25) {	$ses .= $wd[int(rand(@wd))]; }

		# セッション更新
		my @log;
		open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
		eval 'flock(DAT, 2);';
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			next if ($now - $time > $cf{sestime} * 60);

			push(@log,"$_\n");
		}
		unshift(@log,"$ses\t$now\n");
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# クッキー格納
		print "Set-Cookie: $cf{cookie_id3}=$ses\n";

	# セッション確認
	} else {

		# クッキー取得
		my $cook = $ENV{HTTP_COOKIE};

		# 該当IDを取り出す
		my %cook;
		foreach ( split(/;/, $cook) ) {
			my ($key,$val) = split(/=/);
			$key =~ s/\s//g;
			$cook{$key} = $val;
		}

		# クッキーなし
		if ($cook{$cf{cookie_id3}} eq '') { &pwd_form; }

		# ログオフのとき
		if ($in{mode} eq 'logoff') {

			my @log;
			open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
			eval 'flock(DAT, 2);';
			while(<DAT>) {
				my ($id,undef) = split(/\t/);
				next if ($cook{$cf{cookie_id3}} eq $id);

				push(@log,$_);
			}
			seek(DAT, 0, 0);
			print DAT @log;
			truncate(DAT, tell(DAT));
			close(DAT);

			if ($ENV{PERLXS} eq "PerlIS") {
				print "HTTP/1.0 302 Temporary Redirection\r\n";
				print "Content-type: text/html\n";
			}
			print "Set-Cookie: $cf{cookie_id3}=;\n";
			print "Location: $cf{homepage}\n\n";
			exit;
		}

		# セッションチェック
		my $flg;
		open(DAT,"$cf{sesfile}") or error("open err: $cf{sesfile}");
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);

			if ($cook{$cf{cookie_id3}} eq $id) {
				# 時間オーバー
				if ($now - $time > $cf{sestime} * 60) {
					$flg = -1;
				# OK
				} else {
					$flg = 1;
				}
				last;
			}
		}
		close(DAT);

		# 時間オーバー
		if ($flg == -1) {
			my $msg = qq|入室時間が経過しました。再度ログインしてください<br>\n|;
			$msg .= qq|[<a href="$cf{bbs_cgi}?mode=enter">ログイン</a>]\n|;
			&error($msg);

		# セッション情報なし
		} elsif (!$flg) {
			&pwd_form;
		}
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub pwd_form {
	open(IN,"$cf{tmpldir}/enter.html") or error('open err: enter.html');
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	footer($tmpl);
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/honey.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/mobile_honey.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}


1;

